onEvent('recipes', event => {

  // Wooden Barrel Fix
  event.remove({output: 'minecraft:barrel'})
  event.shaped(Item.of('minecraft:barrel'), [
    'PSP',
    'PSP',
    'PSP'
  ], {
    P: '#minecraft:planks',
    S: '#minecraft:wooden_slabs'
  }).id('tnp:wooden_barrel_vanilla')

  // Ladder - Oak
  event.shaped(Item.of('minecraft:ladder', 3), [
    'S S',
    'SSS',
    'S S'
  ], {
    S: '#forge:rods/wooden',
  }).id('tnp:normal_ladder')

  // Chest to Vanilla Trapped Chest
  event.shapeless(Item.of('minecraft:trapped_chest'), ['#forge:chests/wooden', 'minecraft:tripwire_hook', '#minecraft:buttons'])


  // Poisonous Mushroom Chest #1
  event.remove({output: 'extendedmushrooms:poisonous_mushroom_chest'})
  event.shaped(Item.of('extendedmushrooms:poisonous_mushroom_chest'), [
    'PPP',
    'P P',
    'PPP'
  ], {
    P: '#extendedmushrooms:mushroom_planks/poisonous',
  }).id('tnp:poisonous_mushroom_chest_plank')

  // Poisonous Mushroom Chest #2
  event.shaped(Item.of('extendedmushrooms:poisonous_mushroom_chest', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: '#forge:mushroom_stems/green',
  }).id('tnp:poisonous_mushroom_chest_stem')



  // Glowshroom Chest #2
  event.remove({output: 'extendedmushrooms:glowshroom_chest'})
  event.shaped(Item.of('extendedmushrooms:glowshroom_chest'), [
    'PPP',
    'P P',
    'PPP'
  ], {
    P: '#extendedmushrooms:mushroom_planks/glowshroom',
  }).id('tnp:glowshroom_chest_planks')

  //  Glowshroom Chest #2
  event.shaped(Item.of('extendedmushrooms:glowshroom_chest', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: '#forge:mushroom_stems/glowshroom',
  }).id('tnp:glowshroom_chest_stem')



  // Mushroom Chest #3
  event.remove({output: 'extendedmushrooms:mushroom_chest'})
  event.shaped(Item.of('extendedmushrooms:mushroom_chest'), [
    'PPP',
    'P P',
    'PPP'
  ], {
    P: '#extendedmushrooms:mushroom_planks/colorless',
  }).id('tnp:glowshroom_chest_planks_colorless')

  //  Mushroom Chest #3
  event.shaped(Item.of('extendedmushrooms:mushroom_chest', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: '#forge:mushroom_stems/colorless',
  }).id('tnp:glowshroom_chest_stem_colorless')

  // Iron Ingot #1 (Furnace)
  event.replaceInput(
    { id: "minecraft:iron_ingot" },
    "minecraft:iron_ore",
    "#forge:ores/iron"
    )

  // Iron Ingot #2 (Blast)
  event.replaceInput(
    { id: "minecraft:iron_ingot_from_blasting" },
    "minecraft:iron_ore",
    "#forge:ores/iron"
    )

  // Diamond Apple
  event.replaceInput(
    { id: "pickletweaks:diamond_apple" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Emerald Apple
  event.replaceInput(
    { id: "pickletweaks:emerald_apple" },
    "minecraft:emerald",
    "minecraft:emerald_block"
    )

  // Decorative Blocks - Oak Beam
  event.remove({output: 'decorative_blocks:oak_beam'})
  event.shaped(Item.of('decorative_blocks:oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_oak_log',
  }).id('tnp:oak_beam')

  // Decorative Blocks - Dark Oak Beam
  event.remove({output: 'decorative_blocks:dark_oak_beam'})
  event.shaped(Item.of('decorative_blocks:dark_oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_dark_oak_log',
  }).id('tnp:dark_oak_beam')

  // Decorative Blocks - Spruce Beam
  event.remove({output: 'decorative_blocks:spruce_beam'})
  event.shaped(Item.of('decorative_blocks:spruce_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_spruce_log',
  }).id('tnp:spruce_beam')

  // Decorative Blocks - Birch Beam
  event.remove({output: 'decorative_blocks:birch_beam'})
  event.shaped(Item.of('decorative_blocks:birch_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_birch_log',
  }).id('tnp:birch_beam')

  // Decorative Blocks - Jungle Beam
  event.remove({output: 'decorative_blocks:jungle_beam'})
  event.shaped(Item.of('decorative_blocks:jungle_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_jungle_log',
  }).id('tnp:jungle_beam')

  // Decorative Blocks - Acacia Beam
  event.remove({output: 'decorative_blocks:acacia_beam'})
  event.shaped(Item.of('decorative_blocks:acacia_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_acacia_log',
  }).id('tnp:acacia_beam')

  // Decorative Blocks - Crimson Beam
  event.remove({output: 'decorative_blocks:crimson_beam'})
  event.shaped(Item.of('decorative_blocks:crimson_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_crimson_stem',
  }).id('tnp:crimson_beam')

  // Decorative Blocks - Warped Beam
  event.remove({output: 'decorative_blocks:warped_beam'})
  event.shaped(Item.of('decorative_blocks:warped_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:stripped_warped_stem',
  }).id('tnp:warped_beam')

  // Buzzier Bees - Candle
  event.remove({id: 'buzzier_bees:candles/candle'})
  event.shaped(Item.of('buzzier_bees:candle'), [
    ' S ',
    ' W ',
    ' W '
  ], {
    S: '#buzzier_bees:candle_wick',
    W: '#buzzier_bees:candle_base'
  }).id('tnp:bb_candle')

  // Upgrade Aquatic Glass Door
  event.remove({id: 'upgrade_aquatic:glass_door'})
  event.shaped(Item.of('upgrade_aquatic:glass_door'), [
    'GGD',
    'GG ',
    'GG '
  ], {
    G: '#forge:glass/colorless',
    D: '#minecraft:wooden_doors'
  }).id('tnp:ua_glass_door')

  // Abundance Sunflower Seeds
  event.remove({id: 'abundance:crafting/sunflower_seeds'})
  event.shapeless(Item.of('abundance:sunflower_seeds', 4), ['minecraft:sunflower', 'minecraft:sunflower']).id('tnp:sunflower_seeds')

  // Obsidian Pressure Plate
  event.remove({output: 'variant16x:obsidian_pressure_plate'})
  event.shapeless(Item.of('variant16x:obsidian_pressure_plate'), ['minecraft:stone_pressure_plate', 'minecraft:obsidian', 'minecraft:obsidian']).id('tnp:obsidian_pressure_plate')

  // Sand Button
  event.remove({output: 'variant16x:sand_button'})
  event.shapeless(Item.of('variant16x:sand_button'), ['#minecraft:buttons', '#forge:sand/colorless']).id('tnp:sand_button')

  // Red Sand Button
  event.remove({output: 'variant16x:red_sand_button'})
  event.shapeless(Item.of('variant16x:red_sand_button'), ['#minecraft:buttons', '#forge:sand/red']).id('tnp:red_sand_button')

  // Quartz Button
  event.remove({output: 'variant16x:quartz_button'})
  event.shapeless(Item.of('variant16x:quartz_button'), ['#minecraft:buttons', 'minecraft:quartz_block']).id('tnp:quartz_button')

  // Obsidian Button
  event.remove({output: 'variant16x:obsidian_button'})
  event.shapeless(Item.of('variant16x:obsidian_button'), ['#minecraft:buttons', 'minecraft:obsidian']).id('tnp:obsidian_button')

  // Decorative Blocks Bar Panel
  event.remove({id: 'decorative_blocks:bar_panel'})
  event.shaped(Item.of('decorative_blocks:bar_panel', 4), [
    ' B ',
    'B B',
    ' B '
  ], {
    B: 'minecraft:iron_bars',
  }).id('tnp:bar_panel')

  // Emerald Helmet
  event.remove({id: 'pickletweaks:emerald_helmet'})
  event.smithing('pickletweaks:emerald_helmet', 'minecraft:diamond_helmet', 'tnp:emerald_plate').id('tnp:emerald_helmet')

  // Emerald Chestplate
  event.remove({id: 'pickletweaks:emerald_chestplate'})
  event.smithing('pickletweaks:emerald_chestplate', 'minecraft:diamond_chestplate', 'tnp:emerald_plate').id('tnp:emerald_chestplate')

  // Emerald Leggings
  event.remove({id: 'pickletweaks:emerald_leggings'})
  event.smithing('pickletweaks:emerald_leggings', 'minecraft:diamond_leggings', 'tnp:emerald_plate').id('tnp:emerald_leggings')

  // Emerald Boots
  event.remove({id: 'pickletweaks:emerald_boots'})
  event.smithing('pickletweaks:emerald_boots', 'minecraft:diamond_boots', 'tnp:emerald_plate').id('tnp:emerald_boots')



  // Emerald Sword
  event.remove({id: 'pickletweaks:emerald_sword'})
  event.smithing('pickletweaks:emerald_sword', 'minecraft:diamond_sword', 'tnp:emerald_plate').id('tnp:emerald_sword')

  // Emerald Pickaxe
  event.remove({id: 'pickletweaks:emerald_pickaxe'})
  event.smithing('pickletweaks:emerald_pickaxe', 'minecraft:diamond_pickaxe', 'tnp:emerald_plate').id('tnp:emerald_pickaxe')

  // Emerald Shovel
  event.remove({id: 'pickletweaks:emerald_shovel'})
  event.smithing('pickletweaks:emerald_shovel', 'minecraft:diamond_shovel', 'tnp:emerald_plate').id('tnp:emerald_shovel')

  // Emerald Axe
  event.remove({id: 'pickletweaks:emerald_axe'})
  event.smithing('pickletweaks:emerald_axe', 'minecraft:diamond_axe', 'tnp:emerald_plate').id('tnp:emerald_axe')

  // Emerald Hoe
  event.remove({id: 'pickletweaks:emerald_hoe'})
  event.smithing('pickletweaks:emerald_hoe', 'minecraft:diamond_hoe', 'tnp:emerald_plate').id('tnp:emerald_hoe')

  // Emerald Sickle
  event.remove({id: 'pickletweaks:emerald_sickle'})
  event.smithing('pickletweaks:emerald_sickle', 'pickletweaks:diamond_sickle', 'tnp:emerald_plate').id('tnp:emerald_sickle')

  // Emerald Scythe
  event.remove({id: 'pickletweaks:emerald_scythe'})
  event.smithing('pickletweaks:emerald_scythe', 'pickletweaks:diamond_scythe', 'tnp:emerald_plate').id('tnp:emerald_scythe')

  // Emerald Plate
  event.shapeless(Item.of('tnp:emerald_plate'), ['minecraft:emerald', 'minecraft:emerald', 'minecraft:emerald', 'minecraft:emerald']).id('tnp:emerald_plate')

  // Emerald Plate Uncraft
  event.shapeless(Item.of('minecraft:emerald', 4), ['tnp:emerald_plate']).id('tnp:emerald_place_uncraft')

  // Clayblock back to 4x Clay
  event.shapeless(Item.of('minecraft:clay_ball', 4), ['minecraft:clay']).id('tnp:clay_block_uncraft')

  // Quartz Block back to 4x Quartz
  event.shapeless(Item.of('minecraft:quartz', 4), ['minecraft:quartz_block']).id('tnp:quartz_block_uncraft')


  // Golden Melon Slice
  event.shaped(Item.of('tnp:golden_melon_slice'), [
    'NIN',
    'IMI',
    'NIN'
  ], {
    M: 'minecraft:melon_slice',
    N: 'minecraft:gold_nugget',
    I: 'minecraft:gold_ingot'
  }).id('tnp:golden_melon_slice')



  // Golden Berries
  event.shaped(Item.of('tnp:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: '#tnp:golden_berries',
    G: 'minecraft:gold_nugget'
  }).id('tnp:golden_berries')


  // Small Leather Piece to Leather
  event.shapeless(Item.of('minecraft:leather'), ['tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece', 'tnp:small_leather_piece']).id('tnp:leather_pieces_to_leather')

  // Rotten Flesh to Small Leather Piece
  event.smelting(Item.of('tnp:small_leather_piece', 1), 'minecraft:rotten_flesh').xp(0.05).id('tnp:rotten_flesh_to_leather_piece_furnace')
  event.smoking(Item.of('tnp:small_leather_piece', 1), 'minecraft:rotten_flesh').xp(0.05).id('tnp:rotten_flesh_to_leather_piece_smoker')
  event.recipes.minecraft.campfire_cooking('tnp:small_leather_piece', 'minecraft:rotten_flesh').id('tnp:rotten_flesh_to_leather_piece_campfire')

  // Mud Brick Pressureplate
  event.replaceInput(
    { id: "variant16x_biomesoplenty:mud_brick_pressure_plate" },
    "biomesoplenty:cut_white_sandstone",
    "biomesoplenty:mud_bricks"
    )

  // Roasted Onion 1
  event.replaceInput(
    { id: "pamhc2crops:roastedonionitem_campfire" },
    "pamhc2crops:onionitem",
    "farmersdelight:onion"
    )

  // Roasted Onion 2
  event.replaceInput(
    { id: "pamhc2crops:roastedonionitem_forge" },
    "pamhc2crops:onionitem",
    "farmersdelight:onion"
    )

  // Roasted Onion 3
  event.replaceInput(
    { id: "pamhc2crops:roastedonionitem_smoker" },
    "pamhc2crops:onionitem",
    "farmersdelight:onion"
    )

  // Onion Seed
  event.replaceInput(
    { id: "pamhc2crops:onionseeditem" },
    "pamhc2crops:onionitem",
    "farmersdelight:onion"
    )

  // PamHC2 - Sunflower Seed
  event.remove({id: 'pamhc2foodcore:sunflowerseedsitem'})
  event.shapeless(Item.of('pamhc2foodcore:sunflowerseedsitem', 2), ['minecraft:sunflower', 'minecraft:sunflower', 'minecraft:sunflower']).id('tnp:pam_sunflower_seeds')

  // Sea Oats to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['projectvibrantjourneys:sea_oats', 'projectvibrantjourneys:sea_oats']).id('tnp:sticks_from_sea_oats')

  // Ender Pouch
  event.remove({id: 'enderstorage:ender_pouch'})
  event.shaped(Item.of('enderstorage:ender_pouch'), [
    'BLB',
    'LPL',
    'BEB'
  ], {
    B: 'minecraft:blaze_powder',
    L: 'minecraft:leather',
    P: 'minecraft:ender_eye',
    E: 'enderstorage:ender_chest'
  }).id('tnp:ender_pouch')

  // Supplementaries - Door Mat
  event.remove({id: 'supplementaries:doormat'})
  event.shaped(Item.of('supplementaries:doormat'), [
    '   ',
    'SSS',
    '   '
  ], {
    S: '#forge:fiber/flax',
  }).id('tnp:door_mat')

  // Adorn - Crate
  event.remove({id: 'adorn:crates/crate'})
  event.shaped(Item.of('adorn:crate'), [
    'PSP',
    'SPS',
    'PSP'
  ], {
    P: '#minecraft:planks',
    S: '#forge:rods/wooden',
  }).id('tnp:adorn_crate')

  // Dragonite Flower to Cyan Color
  event.shapeless(Item.of('minecraft:cyan_dye'), ['endreborn:dragonite']).id('tnp:dragonite_flower_to_cyan_dye')

  // Cave Root to Cooked Cave Root
  event.smelting(Item.of('tnp:cooked_cave_root', 1), 'quark:root_item').xp(0.25).id('tnp:cooked_cave_root_furnace')
  event.smoking(Item.of('tnp:cooked_cave_root', 1), 'quark:root_item').xp(0.25).id('tnp:cooked_cave_root_smoker')
  event.recipes.minecraft.campfire_cooking('tnp:cooked_cave_root', 'quark:root_item').id('tnp:cooked_cave_root_campfire')


  // Glow Berries to Baked Glow Berries
  event.smelting(Item.of('tnp:baked_glow_berries', 1), 'cavesandcliffs:glow_berries').xp(0.25).id('tnp:baked_glow_berries_furnace')
  event.smoking(Item.of('tnp:baked_glow_berries', 1), 'cavesandcliffs:glow_berries').xp(0.25).id('tnp:baked_glow_berries_smoker')
  event.recipes.minecraft.campfire_cooking('tnp:baked_glow_berries', 'cavesandcliffs:glow_berries').id('tnp:baked_glow_berries_campfire')


  // VT - Crafting Pad
  event.remove({id: 'vanillatweaks:content/crafting_pad'})
  event.shapeless(Item.of('vanillatweaks:pad'), ['#charm:crafting_tables']).id('tnp:crafting_pad')

  // Chain
  event.remove({id: 'minecraft:chain'})
  event.shaped(Item.of('minecraft:chain', 3), [
    ' N ',
    ' I ',
    ' N '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot'
  }).id('tnp:chain')

  // Chainmail Helmet
  event.shaped(Item.of('minecraft:chainmail_helmet'), [
    'CCC',
    'C C',
    '   '
  ], {
    C: 'minecraft:chain',
  }).id('tnp:chainmail_helmet')

  // Chainmail Chestplate
  event.shaped(Item.of('minecraft:chainmail_chestplate'), [
    'C C',
    'CCC',
    'CCC'
  ], {
    C: 'minecraft:chain',
  }).id('tnp:chainmail_chestplate')

  // Chainmail Leggings
  event.shaped(Item.of('minecraft:chainmail_leggings'), [
    'CCC',
    'C C',
    'C C'
  ], {
    C: 'minecraft:chain',
  }).id('tnp:chainmail_leggings')

  // Chainmail Boots
  event.shaped(Item.of('minecraft:chainmail_boots'), [
    '   ',
    'C C',
    'C C'
  ], {
    C: 'minecraft:chain',
  }).id('tnp:chainmail_boots')

  // Soul Glass
  event.shaped(Item.of('nourished_nether:soul_glass', 5), [
    'GSG',
    'SGS',
    'GSG'
  ], {
    G: '#forge:glass',
    S: 'minecraft:soul_sand'
  }).id('tnp:soul_glass')

  // Animal Feed
  event.remove({output: 'essentials:animal_feed'})
  event.shapeless(Item.of('essentials:animal_feed', 2), ['minecraft:beetroot', 'minecraft:carrot', 'minecraft:potato']).id('tnp:animal_feed')

  // Assorted Seeds
  event.remove({id: 'mysticalworld:assorted_seeds_recipe'})
  event.shapeless(Item.of('mysticalworld:assorted_seeds', 3), ['#forge:seeds', '#forge:seeds', '#forge:seeds', '#forge:seeds', '#forge:seeds']).id('tnp:assorted_seeds')

  // Sliced Carrot
  event.replaceInput(
    { id: "mysticalworld:sliced_carrot" },
    "#forge:tools/knife",
    "#farmersdelight:tools/knives"
    )

  // Nautilus Horn
  event.replaceInput(
    { id: "mysticalworld:nautilus_horn" },
    "#forge:tools/knife",
    "#farmersdelight:tools/knives"
    )

  // Sliced Carrot 2
  event.shapeless(Item.of('mysticalworld:sliced_carrot', 4), ['minecraft:carrot', '#forge:tools/knife'])

  // Nautilus Horn 2
  event.shapeless(Item.of('mysticalworld:nautilus_horn'), ['minecraft:nautilus_shell', '#forge:tools/knife'])

  // Sapphire to Netherite Helmet
  event.smithing('minecraft:netherite_helmet', 'mysticalworld:sapphire_helmet', 'minecraft:netherite_ingot').id('tnp:sapphire_helmet_to_netherite')

  // Sapphire to Netherite Chestplate
  event.smithing('minecraft:netherite_chestplate', 'mysticalworld:sapphire_chestplate', 'minecraft:netherite_ingot').id('tnp:sapphire_chestplate_to_netherite')

  // Sapphire to Netherite Leggings
  event.smithing('minecraft:netherite_leggings', 'mysticalworld:sapphire_leggings', 'minecraft:netherite_ingot').id('tnp:sapphire_leggings_to_netherite')

  // Sapphire to Netherite Boots
  event.smithing('minecraft:netherite_boots', 'mysticalworld:sapphire_boots', 'minecraft:netherite_ingot').id('tnp:sapphire_boots_to_netherite')


  // Sapphire to Netherite Sword
  event.smithing('minecraft:netherite_sword', 'mysticalworld:sapphire_sword', 'minecraft:netherite_ingot').id('tnp:sapphire_sword_to_netherite')

  // Sapphire to Netherite Pickaxe
  event.smithing('minecraft:netherite_pickaxe', 'mysticalworld:sapphire_pickaxe', 'minecraft:netherite_ingot').id('tnp:sapphire_pickaxe_to_netherite')

  // Sapphire to Netherite Shovel
  event.smithing('minecraft:netherite_shovel', 'mysticalworld:sapphire_shovel', 'minecraft:netherite_ingot').id('tnp:sapphire_shovel_to_netherite')

  // Sapphire to Netherite Axe
  event.smithing('minecraft:netherite_axe', 'mysticalworld:sapphire_axe', 'minecraft:netherite_ingot').id('tnp:sapphire_axe_to_netherite')

  // Sapphire to Netherite Hoe
  event.smithing('minecraft:netherite_hoe', 'mysticalworld:sapphire_hoe', 'minecraft:netherite_ingot').id('tnp:sapphire_hoe_to_netherite')

  // Mystical World - Mushroom Inside Block
  event.shaped(Item.of('mysticalworld:mushroom_inside_block'), [
    'MMM',
    'MMM',
    'MMM'
  ], {
    M: '#minecraft:mushrooms',
  }).id('tnp:mushroom_inside_block')

  // Mossy Gravel to Gravel
  event.shapeless(Item.of('minecraft:gravel'), ['terraincognita:mossy_gravel']).id('tnp:mossy_gravel_to_gravel')

  // Mug
  event.replaceInput(
    { id: "penguinlib:unfired_mug" },
    "minecraft:clay",
    "minecraft:clay_ball"
    )

  // Plate
  event.replaceInput(
    { id: "penguinlib:unfired_plate" },
    "minecraft:clay",
    "minecraft:clay_ball"
    )

  // Mystical World - Terracotta Bricks
  event.remove({id: 'mysticalworld:terracotta_brick'})
  event.shaped(Item.of('mysticalworld:terracotta_brick', 9), [
    'TTT',
    'TTT',
    'TTT'
  ], {
    T: 'minecraft:terracotta',
  }).id('tnp:terracotta_bricks')

  // Infernal Expansion - Crimson Nylium Carpet
  event.remove({id: 'infernalexp:crafting/crafting_shaped/crimson_nylium_carpet'})
  event.shaped(Item.of('infernalexp:crimson_nylium_carpet', 6), [
    'TT ',
    'TT ',
    '   '
  ], {
    T: 'minecraft:crimson_nylium',
  }).id('tnp:crimson_nylium_carpet')

  // Infernal Expansion - Warped Nylium Carpet
  event.remove({id: 'infernalexp:crafting/crafting_shaped/warped_nylium_carpet'})
  event.shaped(Item.of('infernalexp:warped_nylium_carpet', 6), [
    'TT ',
    'TT ',
    '   '
  ], {
    T: 'minecraft:warped_nylium',
  }).id('tnp:warped_nylium_carpet')

  // Infernal Expansion - Basalt Brick Slabs
  event.remove({id: 'infernalexp:crafting/crafting_shaped/basalt_brick_slab'})
  event.shaped(Item.of('infernalexp:basalt_brick_slab', 6), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'infernalexp:basalt_bricks',
  }).id('tnp:basalt_bricks_slabs')

  // Infernal Expansion - Basalt Brick Wall
  event.replaceOutput(
    { id: "infernalexp:crafting/crafting_shaped/basalt_wall" },
    "infernalexp:basalt_brick_wall",
    "infernalexp:basalt_wall"
    )

  // Basalt Button
  event.remove({id: 'infernalexp:crafting/crafting_shapeless/basalt_button'})
  event.shapeless(Item.of('infernalexp:basalt_button'), ['#minecraft:buttons', 'minecraft:basalt']).id('tnp:basalt_button')

  // Mushrooms to Paper
  event.remove({id: 'infernalexp:crafting/crafting_shaped/paper_from_mushrooms'})
  event.shaped(Item.of('minecraft:paper'), [
    ' M ',
    ' M ',
    ' M '
  ], {
    M: '#forge:mushrooms',
  }).id('tnp:mushrooms_to_paper')

  // Obsidian Recipe with Lava and Water buckets.
  event.shapeless(Item.of('minecraft:obsidian'), ['minecraft:lava_bucket', 'minecraft:water_bucket']).id('tnp:obsidian_lava_water_buckets')

  // Knife
  event.remove({id: 'netheragriculture:crafting_table/knife'})
  event.shaped(Item.of('netheragriculture:knife'), [
    ' K ',
    'S  ',
    '   '
  ], {
    K: 'tnp:knife_head',
    S: '#forge:rods/wooden'
  }).id('tnp:na_knife')

  // Knife Head
  event.shaped(Item.of('tnp:knife_head'), [
    ' I ',
    'N  ',
    '   '
  ], {
    I: 'minecraft:iron_ingot',
    N: 'minecraft:iron_nugget'
  }).id('tnp:tnp_knife_head')

  // DruidCraft - Knife
  event.remove({id: 'druidcraft:knife'})
  event.shaped(Item.of('druidcraft:knife'), [
    '  F',
    ' F ',
    'S  '
  ], {
    F: 'minecraft:flint',
    S: '#forge:rods/wooden'
  }).id('tnp:dc_knife')

  // Simply Steel - Crude Iron
  event.remove({id: 'simplysteel:crude_iron'})
  event.smithing('simplysteel:crude_iron', 'minecraft:iron_ingot', '#minecraft:coals').id('tnp:crude_iron')

  // Weeping Blackstone Bricks
  event.remove({id: 'quark:building/crafting/weeping_blackstone_bricks'})
  event.shapeless(Item.of('quark:weeping_blackstone_bricks'), ['minecraft:polished_blackstone_bricks', 'minecraft:weeping_vines', 'minecraft:weeping_vines']).id('tnp:weeping_blackstone_bricks')

  // Twisted Blackstone Bricks
  event.remove({id: 'quark:building/crafting/twisted_blackstone_bricks'})
  event.shapeless(Item.of('quark:twisted_blackstone_bricks'), ['minecraft:polished_blackstone_bricks', 'minecraft:twisting_vines', 'minecraft:twisting_vines']).id('tnp:twisted_blackstone_bricks')

  // Lattice
  event.remove({output: 'decorative_blocks:lattice'})
  event.shaped(Item.of('decorative_blocks:lattice'), [
    ' S ',
    'SSS',
    ' S '
  ], {
    S: 'minecraft:stick',
  }).id('tnp:lattice')

 // Raw Silver Block
  event.shaped(Item.of('tnp:raw_silver_block'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'tnp:raw_silver',
  }).id('tnp:raw_silver_block')

  // Raw Tin Block
  event.shaped(Item.of('tnp:raw_tin_block'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'tnp:raw_tin',
  }).id('tnp:raw_tin_block')

  // Raw Lead Block
  event.shaped(Item.of('tnp:raw_lead_block'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'tnp:raw_lead',
  }).id('tnp:raw_lead_block')

  // Raw Quicksilver Block
  event.shaped(Item.of('tnp:raw_quicksilver_block'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'tnp:raw_quicksilver',
  }).id('tnp:raw_quicksilver_block')

  event.shapeless(Item.of('tnp:raw_tin', 9), ['tnp:raw_tin_block']).id('tnp:raw_tin_block_uncraft')
  event.shapeless(Item.of('tnp:raw_lead', 9), ['tnp:raw_lead_block']).id('tnp:raw_lead_block_uncraft')
  event.shapeless(Item.of('tnp:raw_silver', 9), ['tnp:raw_silver_block']).id('tnp:raw_silver_block_uncraft')
  event.shapeless(Item.of('tnp:raw_quicksilver', 9), ['tnp:raw_quicksilver_block']).id('tnp:raw_quicksilver_block_uncraft')

  // Glowing Glass Item Frame
  event.shapeless(Item.of('quark:glowing_glass_item_frame'), ['quark:glass_item_frame', 'cavesandcliffs:glow_ink_sac']).id('tnp:glowing_glass_item_frame')

  // Luminous Elder Prismarine
  event.replaceInput(
    { id: "upgrade_aquatic:luminous_elder_prismarine" },
    "upgrade_aquatic:glowing_ink_sac",
    "cavesandcliffs:glow_ink_sac"
    )

  // Luminous Prismarine
  event.replaceInput(
    { id: "upgrade_aquatic:luminous_prismarine" },
    "upgrade_aquatic:glowing_ink_sac",
    "cavesandcliffs:glow_ink_sac"
    )

  // Copper Nuggets from Ingot
  event.shapeless(Item.of('tnp:copper_nugget', 9), ['#forge:ingots/copper']).id('tnp:copper_nuggets_from_ingot')

  // Copper Ingot from Nuggets
  event.shaped(Item.of('cavesandcliffs:copper_ingot'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'tnp:copper_nugget',
  }).id('tnp:copper_ingot_from_nuggets')

  // Green Apple to Green Baked Apple
  event.smelting(Item.of('tnp:green_baked_apple', 1), 'byg:green_apple').xp(0.35).id('tnp:green_baked_apple_furnace')
  event.smoking(Item.of('tnp:green_baked_apple', 1), 'byg:green_apple').xp(0.35).id('tnp:green_baked_apple_smoker')
  event.recipes.minecraft.campfire_cooking('tnp:green_baked_apple', 'byg:green_apple').id('tnp:green_baked_apple_campfire')

  // Willow Post
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_post" },
    "biomesoplenty:willow_planks",
    "environmental:willow_planks"
    )

  // Willow Platform
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_platform" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Step
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_step" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Drawer
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_drawer" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Chair
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_chair" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Table
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_table" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Bench
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_bench" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Coffee Table
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_coffee_table" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Shelf
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_shelf" },
    "biomesoplenty:willow_slab",
    "environmental:willow_slab"
    )

  // Willow Kitchen Counter
  event.replaceInput(
    { id: "adorn:biomesoplenty/willow_kitchen_counter" },
    "biomesoplenty:willow_planks",
    "environmental:willow_planks"
    )

  // Cypress Post
  event.replaceInput(
    { id: "adorn:byg/cypress_post" },
    "byg:cypress_planks",
    "bayou_blues:cypress_planks"
    )

  // Cypress Platform
  event.replaceInput(
    { id: "adorn:byg/cypress_platform" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Step
  event.replaceInput(
    { id: "adorn:byg/cypress_step" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Drawer
  event.replaceInput(
    { id: "adorn:byg/cypress_drawer" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Chair
  event.replaceInput(
    { id: "adorn:byg/cypress_chair" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Table
  event.replaceInput(
    { id: "adorn:byg/cypress_table" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Bench
  event.replaceInput(
    { id: "adorn:byg/cypress_bench" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Coffee Table
  event.replaceInput(
    { id: "adorn:byg/cypress_coffee_table" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Shelf
  event.replaceInput(
    { id: "adorn:byg/cypress_shelf" },
    "byg:cypress_slab",
    "bayou_blues:cypress_slab"
    )

  // Cypress Kitchen Counter
  event.replaceInput(
    { id: "adorn:byg/cypress_kitchen_counter" },
    "byg:cypress_planks",
    "bayou_blues:cypress_planks"
    )

  // Mangrove Post
  event.replaceInput(
    { id: "adorn:byg/mangrove_post" },
    "byg:mangrove_planks",
    "unnamedanimalmod:mangrove_planks"
    )

  // Mangrove Platform
  event.replaceInput(
    { id: "adorn:byg/mangrove_platform" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Step
  event.replaceInput(
    { id: "adorn:byg/mangrove_step" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Drawer
  event.replaceInput(
    { id: "adorn:byg/mangrove_drawer" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Chair
  event.replaceInput(
    { id: "adorn:byg/mangrove_chair" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Table
  event.replaceInput(
    { id: "adorn:byg/mangrove_table" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Bench
  event.replaceInput(
    { id: "adorn:byg/mangrove_bench" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Coffee Table
  event.replaceInput(
    { id: "adorn:byg/mangrove_coffee_table" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Shelf
  event.replaceInput(
    { id: "adorn:byg/mangrove_shelf" },
    "byg:mangrove_slab",
    "unnamedanimalmod:mangrove_slab"
    )

  // Mangrove Kitchen Counter
  event.replaceInput(
    { id: "adorn:byg/mangrove_kitchen_counter" },
    "byg:mangrove_planks",
    "unnamedanimalmod:mangrove_planks"
    )

  // Reed Thatch
  event.replaceInput(
    { id: "byg:reed_thatch" },
    "byg:reeds",
    "#forge:reeds"
    )

  // Reed Bundle
  event.replaceInput(
    { id: "terraincognita:compat/quark/reeds_block" },
    "terraincognita:reeds",
    "#forge:reeds"
    )

  // Mangrove Sign Hanging
  event.replaceInput(
    { id: "supplementaries:hanging_sign_mangrove" },
    "byg:mangrove_planks",
    "unnamedanimalmod:mangrove_planks"
    )

  // Mangrove Sign Post
  event.replaceInput(
    { id: "supplementaries:sign_post_mangrove" },
    "byg:mangrove_planks",
    "unnamedanimalmod:mangrove_planks"
    )

  // Lavender Mashed Potatoes
  event.replaceInput(
    { id: "irregularchef:lavender_mashed_potatoes" },
    "abundance:lavender",
    "#forge:flowers/lavender"
    )

  // Lavender Salad
  event.replaceInput(
    { id: "abundance:crafting/lavender_salad" },
    "abundance:lavender",
    "#forge:flowers/lavender"
    )

  // Leaf Carpet - Jacaranda Leaves
  event.replaceInput(
    { id: "abundance:crafting/jacaranda_leaf_carpet" },
    "abundance:jacaranda_leaves",
    "biomesoplenty:jacaranda_leaves"
    )


  // Campful - Jacaranda Campfire
  event.replaceInput(
    { id: "campful:jacaranda_campfire" },
    "#abundance:jacaranda_logs",
    "#biomesoplenty:jacaranda_logs"
    )

  // Campful - Soul Jacaranda Campfire
  event.replaceInput(
    { id: "campful:soul_jacaranda_campfire" },
    "#abundance:jacaranda_logs",
    "#biomesoplenty:jacaranda_logs"
    )

  // Campful - Ender Jacaranda Campfire
  event.replaceInput(
    { id: "campful:ender_jacaranda_campfire" },
    "#abundance:jacaranda_logs",
    "#biomesoplenty:jacaranda_logs"
    )

  // Cherry Bars
  event.replaceInput(
    { id: "additionalbarsbop:cherry_bars" },
    "biomesoplenty:cherry_log",
    "environmental:cherry_log"
    )

  // Netherite Helmet
  event.replaceInput(
    { id: "minecraft:netherite_helmet_smithing" },
    "morevanillaarmor:emerald_helmet",
    "minecraft:diamond_helmet"
    )

  // Netherite Chestplate
  event.replaceInput(
    { id: "minecraft:netherite_chestplate_smithing" },
    "morevanillaarmor:emerald_chestplate",
    "minecraft:diamond_chestplate"
    )

  // Netherite Leggings
  event.replaceInput(
    { id: "minecraft:netherite_leggings_smithing" },
    "morevanillaarmor:emerald_leggings",
    "minecraft:diamond_leggings"
    )

  // Netherite Boots
  event.replaceInput(
    { id: "minecraft:netherite_boots_smithing" },
    "morevanillaarmor:emerald_boots",
    "minecraft:diamond_boots"
    )

  // Sunflower Seed Cookie
  event.replaceInput(
    { id: "vanillacookbook:sunflower_seed_cookie" },
    "minecraft:sunflower",
    "#forge:nuts/sunflowerseeds"
    )

  // Rusty Iron Ingot
  event.remove({id: 'dustrial_decor:rusty_iron_ingot'})
  event.shaped(Item.of('dustrial_decor:rusty_iron_ingot', 4), [
    ' I ',
    'IWI',
    ' I '
  ], {
    I: 'minecraft:iron_ingot',
    W: 'minecraft:water_bucket'
  }).id('tnp:rusty_iron_ingot')

  // Red Mushroom Button
  event.remove({id: 'extendedmushrooms:mushroom_cap/red/red_mushroom_button'})
  event.shapeless(Item.of('extendedmushrooms:red_mushroom_button'), ['#minecraft:buttons', 'minecraft:red_mushroom_block']).id('tnp:red_mushroom_button')

  // Full Red Mushroom Full
  event.remove({id: 'mysticalworld:full_stem_mushroom_block_from_stem_mushroom'})
  event.shaped(Item.of('mysticalworld:stem_mushroom_full', 2), [
    ' M ',
    'M  ',
    '   '
  ], {
    M: 'minecraft:mushroom_stem',
  }).id('tnp:full_red_mushroom_stem_block')

  // Full Brown Mushroom Full
  event.remove({id: 'mysticalworld:full_brown_mushroom_block_from_brown_mushroom'})
  event.shaped(Item.of('mysticalworld:brown_mushroom_full', 2), [
    ' M ',
    'M  ',
    '   '
  ], {
    M: 'minecraft:brown_mushroom_block',
  }).id('tnp:full_brown_mushroom_stem_block')

  // Iron Bar Trap Door
  event.remove({id: 'dustrial_decor:iron_bar_trapdoor'})
  event.smithing('dustrial_decor:iron_bar_trapdoor', 'minecraft:iron_trapdoor', 'minecraft:iron_bars').id('tnp:iron_bar_trapdoor')

  // Iron Horse Armor
  event.shaped(Item.of('minecraft:iron_horse_armor'), [
    'I I',
    'III',
    'I I'
  ], {
    I: 'minecraft:iron_ingot',
  }).id('tnp:iron_horse_armor')

  // Gold Horse Armor
  event.shaped(Item.of('minecraft:golden_horse_armor'), [
    'G G',
    'GGG',
    'G G'
  ], {
    G: 'minecraft:gold_ingot',
  }).id('tnp:golden_horse_armor')

  // Diamond Horse Armor
  event.shaped(Item.of('minecraft:diamond_horse_armor'), [
    'D D',
    'DDD',
    'D D'
  ], {
    D: 'minecraft:diamond',
  }).id('tnp:diamond_horse_armor')

  // 9x Diamond Nuggets to Diamond
  event.shaped(Item.of('minecraft:diamond'), [
    'DDD',
    'DDD',
    'DDD'
  ], {
    D: 'tnp:diamond_nugget',
  }).id('tnp:diamond_nuggets_to_diamond')

  // Diamond to Diamond Nuggets
  event.shapeless(Item.of('tnp:diamond_nugget', 9), ['minecraft:diamond']).id('tnp:diamond_to_diamond_nuggets')

  // 9x Emerald Nuggets to Emerald
  event.shaped(Item.of('minecraft:emerald'), [
    'EEE',
    'EEE',
    'EEE'
  ], {
    E: 'tnp:emerald_nugget',
  }).id('tnp:emerald_nuggets_to_emerald')

  // Emerald to Emerald Nuggets
  event.shapeless(Item.of('tnp:emerald_nugget', 9), ['minecraft:emerald']).id('tnp:emerald_to_emerald_nuggets')

  // Iron Magnetic Core
  event.shaped('tnp:iron_magnetic_core', [
    'III',
    'IEI',
    'III'
  ], {
    I: 'minecraft:iron_block',
    E: Item.of('minecraft:enchanted_book', {StoredEnchantments:[{lvl:5,id:"minecraft:efficiency"}]})
  }).id('tnp:iron_magnetic_core')

  // Golden Magnetic Core
  event.shaped('tnp:gold_magnetic_core', [
    'GGG',
    'GEG',
    'GGG'
  ], {
    G: 'minecraft:gold_block',
    E: Item.of('minecraft:enchanted_book', {StoredEnchantments:[{lvl:5,id:"minecraft:efficiency"}]})
  }).id('tnp:gold_magnetic_core')

  // Diamond Magnetic Core
  event.shaped('tnp:diamond_magnetic_core', [
    'DDD',
    'DED',
    'DDD'
  ], {
    D: 'minecraft:diamond_block',
    E: Item.of('minecraft:enchanted_book', {StoredEnchantments:[{lvl:5,id:"minecraft:efficiency"}]})
  }).id('tnp:diamond_magnetic_core')

  // Netherite Magnetic Core
  event.shaped('tnp:netherite_magnetic_core', [
    'NNN',
    'NEN',
    'NNN'
  ], {
    N: 'minecraft:netherite_block',
    E: Item.of('minecraft:enchanted_book', {StoredEnchantments:[{lvl:5,id:"minecraft:efficiency"}]})
  }).id('tnp:netherite_magnetic_core')

  // Emerald Magnetic Core
  event.shaped('tnp:emerald_magnetic_core', [
    'EEE',
    'EBE',
    'EEE'
  ], {
    E: 'minecraft:emerald_block',
    B: Item.of('minecraft:enchanted_book', {StoredEnchantments:[{lvl:5,id:"minecraft:efficiency"}]})
  }).id('tnp:emerald_magnetic_core')

  // Iron Hammer
  event.remove({output: 'vanillahammers:iron_hammer'})
  event.smithing('vanillahammers:iron_hammer', 'minecraft:iron_pickaxe', 'tnp:iron_magnetic_core').id('tnp:iron_hammer')

  // Gold Hammer
  event.remove({output: 'vanillahammers:gold_hammer'})
  event.smithing('vanillahammers:gold_hammer', 'minecraft:golden_pickaxe', 'tnp:gold_magnetic_core').id('tnp:golden_hammer')

  // Diamond Hammer
  event.remove({output: 'vanillahammers:diamond_hammer'})
  event.smithing('vanillahammers:diamond_hammer', 'minecraft:diamond_pickaxe', 'tnp:diamond_magnetic_core').id('tnp:diamond_hammer')

  // Netherite Hammer
  event.remove({output: 'vanillahammers:netherite_hammer'})
  event.smithing('vanillahammers:netherite_hammer', 'minecraft:netherite_pickaxe', 'tnp:netherite_magnetic_core').id('tnp:netherite_hammer')

  // Emerald Hammer
  event.remove({output: 'vanillahammers:emerald_hammer'})
  event.smithing('vanillahammers:emerald_hammer', 'pickletweaks:emerald_pickaxe', 'tnp:emerald_magnetic_core').id('tnp:emerald_hammer')



  // Iron Excavator
  event.remove({output: 'vanillaexcavators:iron_excavator'})
  event.smithing('vanillaexcavators:iron_excavator', 'minecraft:iron_shovel', 'tnp:iron_magnetic_core').id('tnp:iron_excavator')

  // Gold Excavator
  event.remove({output: 'vanillaexcavators:gold_excavator'})
  event.smithing('vanillaexcavators:gold_excavator', 'minecraft:golden_shovel', 'tnp:gold_magnetic_core').id('tnp:golden_excavator')

  // Diamond Excavator
  event.remove({output: 'vanillaexcavators:diamond_excavator'})
  event.smithing('vanillaexcavators:diamond_excavator', 'minecraft:diamond_shovel', 'tnp:diamond_magnetic_core').id('tnp:diamond_excavator')

  // Netherite Excavator
  event.remove({output: 'vanillaexcavators:netherite_excavator'})
  event.smithing('vanillaexcavators:netherite_excavator', 'minecraft:netherite_shovel', 'tnp:netherite_magnetic_core').id('tnp:netherite_excavator')

  // Emerald Excavator
  event.remove({output: 'vanillaexcavators:emerald_excavator'})
  event.smithing('vanillaexcavators:emerald_excavator', 'pickletweaks:emerald_shovel', 'tnp:emerald_magnetic_core').id('tnp:emerald_excavator')

  // Quark Oak Chest with Planks
  event.shaped(Item.of('quark:oak_chest'), [
    'PPP',
    'P P',
    'PPP'
  ], {
    P: '#chest:planks',
  }).id('tnp:oak_chest_planks')

  // Quark Oak Chest with Logs
  event.shaped(Item.of('quark:oak_chest', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: '#chest:logs',
  }).id('tnp:oak_chest_logs')

  // Quark Birch Chest with Birch Logs
  event.shaped(Item.of('quark:birch_chest', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: '#birch_chest:logs',
  }).id('tnp:birch_chest_log')

  // Empty Mug
  event.remove({id: 'frozenup:empty_mug'})
  event.shaped(Item.of('frozenup:empty_mug'), [
    'B B',
    'B B',
    'BBB'
  ], {
    B: 'minecraft:brick',
  }).id('tnp:empty_mug')

  // Slabfish Effigy
  event.replaceInput(
    { id: "environmental:building/slabfish_effigy" },
    "environmental:mud_brick",
    "#forge:ingot_mud_bricks"
    )

  // BOP - Mud Bricks 
  event.replaceInput(
    { id: "biomesoplenty:mud_bricks" },
    "biomesoplenty:mud_brick",
    "#forge:ingot_mud_bricks"
    )

  // Dirt Cup #1
  event.replaceInput(
    { id: "irregularchef:dirt_cup" },
    "upgrade_aquatic:glowing_ink_sac",
    "cavesandcliffs:glow_ink_sac"
    )

  // Dirt Cup #2
  event.replaceInput(
    { id: "irregularchef:dirt_cup" },
    "environmental:mud_ball",
    "biomesoplenty:mud_ball"
    )

  // Stone Rod
  event.replaceInput(
    { id: "adorn:stone_rod" },
    "minecraft:stone",
    "#quark:stone_tool_materials"
    )

  // Blueberry Pie
  event.replaceInput(
    { id: "byg:blueberry_pie" },
    "byg:blueberries",
    "#forge:fruits/blueberries"
    )

  // Blueberry Muffin
  event.replaceInput(
    { id: "druidcraft:blueberry_muffin" },
    "druidcraft:blueberries",
    "#forge:fruits/blueberries"
    )

  // Rose Tangled Violite
  event.remove({id: 'outer_end:rose_tangled_violite'})
  event.shaped(Item.of('outer_end:rose_tangled_violite'), [
    'RRR',
    'RRR',
    'RVR'
  ], {
    R: 'outer_end:rose_crystal',
    V: 'outer_end:violite'
  }).id('tnp:rose_tangled_violite')

  // Mint Tangled Violite
  event.remove({id: 'outer_end:mint_tangled_violite'})
  event.shaped(Item.of('outer_end:mint_tangled_violite'), [
    'RRR',
    'RRR',
    'RVR'
  ], {
    R: 'outer_end:mint_crystal',
    V: 'outer_end:violite'
  }).id('tnp:mint_tangled_violite')

  // Cobalt Tangled Violite
  event.remove({id: 'outer_end:cobalt_tangled_violite'})
  event.shaped(Item.of('outer_end:cobalt_tangled_violite'), [
    'RRR',
    'RRR',
    'RVR'
  ], {
    R: 'outer_end:cobalt_crystal',
    V: 'outer_end:violite'
  }).id('tnp:cobalt_tangled_violite')

  // Mushroom Spores
  event.remove({id: 'extendedmushrooms:mushroom_spores'})
  event.shaped(Item.of('extendedmushrooms:mushroom_spores'), [
    'M  ',
    'M  ',
    '   '
  ], {
    M: '#forge:mushrooms',
  }).id('tnp:mushroom_spores')

  // Floral Basket
  event.remove({id: 'floralench:floral_basket'})
  event.shaped(Item.of('floralench:floral_basket'), [
    'W W',
    'W W',
    'WWW'
  ], {
    W: 'minecraft:wheat',
  }).id('tnp:floral_basket')

  // Mushroom Cap Button
  event.remove({id: 'extendedmushrooms:mushroom_cap/poisonous_mushroom/poisonous_mushroom_cap_button'})
  event.shaped(Item.of('extendedmushrooms:poisonous_mushroom_cap_button'), [
    'E  ',
    'E  ',
    '   '
  ], {
    E: 'extendedmushrooms:poisonous_mushroom_cap',
  }).id('tnp:poisonous_mushroom_cap_button')

  // Mushroom Cap Button
  event.remove({id: 'extendedmushrooms:mushroom_cap/brown/brown_mushroom_button'})
  event.shaped(Item.of('extendedmushrooms:brown_mushroom_button'), [
    'E  ',
    'E  ',
    '   '
  ], {
    E: 'minecraft:brown_mushroom_block',
  }).id('tnp:brown_mushroom_cap_button')

  // Glowshroom Cap Button
  event.remove({id: 'extendedmushrooms:mushroom_cap/glowshroom/glowshroom_cap_button'})
  event.shaped(Item.of('extendedmushrooms:glowshroom_cap_button'), [
    'E  ',
    'E  ',
    '   '
  ], {
    E: 'extendedmushrooms:glowshroom_cap',
  }).id('tnp:glowshroom_cap_button')

  // Scoria Pillar
  event.remove({id: 'byg:scoria_pillar'})
  event.shaped(Item.of('byg:scoria_pillar', 2), [
    ' S ',
    ' S ',
    ' S '
  ], {
    S: 'byg:scoria_stone',
  }).id('tnp:scoria_pillar')

  // Dacite Pillar
  event.remove({id: 'byg:dacite_pillar'})
  event.shaped(Item.of('byg:dacite_pillar', 2), [
    ' S ',
    ' S ',
    ' S '
  ], {
    S: 'byg:dacite',
  }).id('tnp:dacite_pillar')

  // Soapstone Pillar
  event.remove({id: 'byg:soapstone_pillar'})
  event.shaped(Item.of('byg:soapstone_pillar', 2), [
    ' S ',
    ' S ',
    ' S '
  ], {
    S: 'byg:soapstone',
  }).id('tnp:soapstone_pillar')

  // Better End - Iron Hammer
  event.remove({id: 'betterendforge:iron_hammer'})
  event.shaped(Item.of('betterendforge:iron_hammer'), [
    'ISI',
    'IS ',
    ' S '
  ], {
    S: '#forge:rods/wooden',
    I: 'minecraft:iron_ingot',
  }).id('tnp:be_iron_hammer')

  // Stone Tool Fix
  event.replaceInput({id: 'minecraft:stone_sword'}, 'minecraft:cobblestone', '#minecraft:stone_tool_materials')
  event.replaceInput({id: 'minecraft:stone_pickaxe'}, 'minecraft:cobblestone', '#minecraft:stone_tool_materials')
  event.replaceInput({id: 'minecraft:stone_shovel'}, 'minecraft:cobblestone', '#minecraft:stone_tool_materials')
  event.replaceInput({id: 'minecraft:stone_axe'}, 'minecraft:cobblestone', '#minecraft:stone_tool_materials')
  event.replaceInput({id: 'minecraft:stone_hoe'}, 'minecraft:cobblestone', '#minecraft:stone_tool_materials')

  // Sulphuric Rock Furnace
  event.remove({id: 'betterendforge:sulphuric_rock_furnace'})
  event.shaped(Item.of('betterendforge:sulphuric_rock_furnace'), [
    'SSS',
    'SFS',
    'SSS'
  ], {
    S: 'betterendforge:sulphuric_rock',
    F: 'minecraft:furnace',
  }).id('tnp:sulphuric_rock_furnace')

  // Violecite Rock Furnace
  event.remove({id: 'betterendforge:violecite_furnace'})
  event.shaped(Item.of('betterendforge:violecite_furnace'), [
    'SSS',
    'SFS',
    'SSS'
  ], {
    S: 'betterendforge:violecite',
    F: 'minecraft:furnace',
  }).id('tnp:violecite_furnace')

  // Flavolite Rock Furnace
  event.remove({id: 'betterendforge:flavolite_furnace'})
  event.shaped(Item.of('betterendforge:flavolite_furnace'), [
    'SSS',
    'SFS',
    'SSS'
  ], {
    S: 'betterendforge:flavolite',
    F: 'minecraft:furnace',
  }).id('tnp:flavolite_furnace')

  // Kousa Seat
  event.shaped(Item.of('muchmoremodcompat:kousa_seat', 2), [
    ' P ',
    ' F ',
    '   '
  ], {
    P: 'atmospheric:kousa_planks',
    F: 'atmospheric:kousa_fence',
  }).id('tnp:kousa_seat')

  // Red Mushroom Full
  event.remove({id: 'mysticalworld:full_red_mushroom_block_from_red_mushroom'})
  event.shaped(Item.of('mysticalworld:red_mushroom_full', 4), [
    'MM ',
    'MM ',
    '   '
  ], {
    M: 'minecraft:red_mushroom_block',
  }).id('tnp:red_mushroom_full')

  // Stonebrick Stairs
  event.shaped(Item.of('minecraft:stone_brick_stairs', 4), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'minecraft:stone_bricks',
  }).id('minecraft:stone_brick_stairs')

  event.smelting(Item.of('quark:smooth_basalt'), 'minecraft:basalt').xp(0.1)

  // Quark - Smooth Basalt Stairs
  event.shaped(Item.of('quark:smooth_basalt_stairs', 4), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'quark:smooth_basalt',
  }).id('tnp:smooth_basalt_stairs')

  // Quark - Smooth Basalt Slabs
  event.shaped(Item.of('quark:smooth_basalt_slab', 4), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'quark:smooth_basalt',
  }).id('tnp:smooth_basalt_slab')

  // Quark - Smooth Basalt Wall
  event.shaped(Item.of('quark:smooth_basalt_wall', 6), [
    '   ',
    'BBB',
    'BBB'
  ], {
    B: 'quark:smooth_basalt',
  }).id('tnp:smooth_basalt_wall')

  // Malachite Ore Blast Fix
  event.blasting(Item.of('nourished_end:malachite', 1), 'nourished_end:malachite_ore').xp(1.0).id('tnp:malachite_ore_blasting')

});